#include "combined_grade_average.hpp"

#include "combined_grade_list.hpp"

void CombinedGradeAverage::recalculate() noexcept {

    const auto &gradesRef =
        std::get<const CombinedGradeList &>(this->mParentRefs);

    auto sumAll = 0., sumPassed = 0.;
    auto nrPassed = 0;

    // Add all passing grades / all grades together.
    // Count how many students passed.
    for (const auto grade : gradesRef.mGrades) {
        const auto gradeDouble = gradeToDouble(grade);

        sumAll += gradeDouble;

        if (grade != Grade::grade5_0) {
            sumPassed += gradeDouble;
            ++nrPassed;
        }
    }

    mAverageGrade = sumAll / static_cast<double>(gradesRef.mGrades.size());
    mAverageGradePassed = sumPassed / static_cast<double>(nrPassed);
}
